<template>
  <div>
    <h4 class="centered">{{ meal.period | computedPeriod }}</h4>

    <table
      class="ui compact table"
      :class="pavillon.validated ? 'green' : 'orange'"
    >
      <thead>
        <tr>
          <th>Régime</th>
          <th>Menu</th>
          <th>Patients</th>
          <th class="right aligned">Total</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>
            Ordinaire
          </td>
          <td>
            {{ meal.menu.dishes.join(', ') }}
          </td>
          <td>
            {{
              patients.filter(p => p.hasOrdinaryDiet === true)
                .map(e => e.firstname + ' ' + e.lastname)
                .join(', ')
            }}
          </td>
          <td class="right aligned">
            {{ patients.filter(p => p.hasOrdinaryDiet === true).length }}
          </td>
        </tr>

        <tr
          v-for="variant in variants"
          :key="variant._id"
          v-if="getPatientsDiets(variant).length > 0"
        >
          <td>
            {{ variant.diet.name }}
          </td>
          <td>
            {{ variant.dishes.join(', ') }}
          </td>
          <td>
            {{ getPatientsDiets(variant).map(e => e.firstname + ' ' + e.lastname).join(', ') }}
          </td>
          <td class="right aligned">
            {{ getPatientsDiets(variant).length }}
          </td>
        </tr>

        <tr
          class="negative"
          v-if="specialPatients.length > 0"
        >
          <td>
            Spécial !
          </td>
          <td>
            Requiert un menu personnalisé
          </td>
          <td>
            <b style="color: red">
              {{
                specialPatients.map(e => e.firstname + ' ' + e.lastname + ' (' + e.diets.map(d => d.name).join(', ') + ')')
                  .join(', ')
              }}
            </b>
          </td>
          <td class="right aligned">
            {{ specialPatients.length }}
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import store from '@/store/Store'

export default {
  name: 'PariodCard',
  store,
  props: {
    meal: Object,
    variants: Array,
    patients: Array,
    pavillon: Object
  },
  methods: {
    getPatientsDiets (variant) {
      return this.patients.filter(p => {
        let res = false
        if (p.hasOrdinaryDiet === false && p.diets.length === 1) {
          p.diets.forEach(d => {
            if (d._id === variant.diet._id) {
              res = true
            }
          })
        }
        return res
      })
    }
  },
  computed: {
    specialPatients () {
      // ajouter avec les ordinaires si
      // pas de variant pour lui ou
      // plus de 2 régimes
      let patients = []
      this.patients.forEach(p => {
        let add = true
        if (p.diets.length > 0) {
          p.diets.forEach(d => {
            this.variants.forEach(v => {
              if (d._id === v.diet._id) {
                add = false
              }
            })
          })
        } else {
          add = false
        }
        if (p.diets.length > 1) {
          add = true
        }
        if (add) {
          patients.push(p)
        }
      })
      return patients
    }
  }
}
</script>
